#include "ExecAction.h"

void ExecAction::runCommand()
{
  if (cmd->isEmpty())
  {
    qDebug() << "error: command is undefined.";
    return;
  }
  qDebug() << "Executing" << cmd->constData();

  pid_t pid = fork();
  if (pid == 0)
  {
    if (runAsRootKDE || runAsRootGTK)
    {
      QByteArray tmp;
      if (runAsRootKDE)
      {
        tmp = "kdesu " + *cmd;
      }
      else
      {
        tmp = "gksu " + *cmd;
      }
      system(tmp.constData());
    }
    else
    {
        system(cmd->constData());
    }
    exit(0);
  }
}

void ExecAction::setCommand(QByteArray cmd)
{
  this->cmd = new QByteArray(cmd);
}

void ExecAction::setRunAsRootKDE()
{
  runAsRootKDE = true;
  runAsRootGTK = false;
}

void ExecAction::setRunAsRootGTK()
{
  runAsRootKDE = false;
  runAsRootGTK = true;
}
