#include <QMenu>
#include <QDebug>
#include <QFile>
#include <QTextStream>
#include <QByteArray>
#include <QApplication>
#include <QMessageBox>

#include "ExecAction.h"

#include <cstdio>

class Menu : public QMenu
{
  Q_OBJECT
public:
  Menu(QApplication *app) : QMenu()
  {
    this->app = app;
    filename = QString(getenv("HOME")) + "/.qmymenurc";

    qDebug() << "Generating the menu...";
    qDebug() << "Using config file" << filename;
    if (! QFile::exists(filename))
    {
      qDebug() << "The menu does not exist. Writing a sample one.";
      QFile::copy(":/conf/sample.conf", filename);
      QFile::setPermissions(filename, QFile::WriteOwner | QFile::ReadOwner | QFile::ReadGroup | QFile::ReadOther);
    }
    updateMenu();
  }

  QAction *quitAct;

private:
  QString filename;
  QApplication *app;
  QFile *nextLine(QString line, int &lineno, ExecAction *&act, QMenu *&currentSubmenu);
  FILE *readDynamicEntry(QString cmd);

public slots:
  void updateMenu();
};
